package com.steerinfo.ems.tpmcaseact.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.ems.tpmcaseact.model.TPmCaseAct;
import com.steerinfo.ems.tpmcaseact.service.ITPmCaseActService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Set;

/**
 * TPmCaseAct RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2019-10-11 10:28
 * 类描述
 * 修订历史：
 * 日期：2019-10-11
 * 作者：generator
 * 参考：
 * 描述：TPmCaseAct RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/tpmcaseacts")
public class TPmCaseActController extends BaseRESTfulController {

    @Autowired
    ITPmCaseActService tPmCaseActService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("tpmcaseact:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<TPmCaseAct> list = tPmCaseActService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("tpmcaseact:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<TPmCaseAct> list = tPmCaseActService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据TPmCaseAct对象创建")
    @ApiImplicitParam(name = "tPmCaseAct", value = "详细实体tPmCaseAct", required = true, dataType = "TPmCaseAct")
    //@RequiresPermissions("tpmcaseact:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody TPmCaseAct model){
        StringBuffer sb = new StringBuffer();
        sb.append(model.getTimegranid());
        sb.append(model.getItemid());
        Set<String> strings = tPmCaseActService.CompositePrimaryKey();
        for (String string : strings) {
            if(string.equals(sb.toString())){
                return failed(model,"计划项目推荐方案已存在");
            }
        }
        TPmCaseAct tPmCaseAct = tPmCaseActService.add(model);
        return success(tPmCaseAct);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的tPmCaseAct信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "tPmCaseAct", value = "详细实体tPmCaseAct", required = true, dataType = "TPmCaseAct")
    })
    //@RequiresPermissions("tpmcaseact:update")
    @PutMapping(value = "/{str}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String str,
                                @RequestBody TPmCaseAct model){
        String[] split = str.split(",");
        model.setTimegranid(split[0]);
        model.setItemid(split[1]);
        System.out.println(model);
        TPmCaseAct tPmCaseAct = tPmCaseActService.modify(model);
        return success(tPmCaseAct);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "itemid", value = "ITEMID", required = true, dataType = "String")
    //@RequiresPermissions("tpmcaseact:delete")
    @DeleteMapping(value = "/{str}")
    public RESTfulResult delete(@PathVariable String str){
        String[] split = str.split(",");
        TPmCaseAct tp = new TPmCaseAct();
        tp.setTimegranid(split[0]);
        tp.setItemid(split[1]);
        tPmCaseActService.deleteByCompositePrimaryKey(tp);
        return success();
    }



}
